#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if HAVE_UNISTD_H
#include <unistd.h>
#endif
#if HAVE_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif
#include <sys/types.h>
#if HAVE_NETINET_IN_H
# include <netinet/in.h>
#endif
#if TIME_WITH_SYS_TIME
# ifdef WIN32
#  include <sys/timeb.h>
# else
#  include <sys/time.h>
# endif
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif
#if HAVE_SYS_SELECT_H
#include <sys/select.h>
#endif
#if HAVE_WINSOCK_H
#include <winsock.h>
#endif
#if HAVE_NETDB_H
#include <netdb.h>
#endif
#if HAVE_ARPA_INET_H
#include <arpa/inet.h>
#endif


#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <string.h>

#include <mysql.h>

#ifndef USERTRACKERH
#define USERTRACKERH


#include <syslog.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef LINUX
	#include <getopt.h>
#endif

#define MAXSTR 255
#define MAXQUERYLEN 512

//#define debug

#define LISTE "/var/log/tracker_ip_list" 		// IP listesinin yazilacagi liste
#define CEVAPVAR "/var/log/tracker_alive_ips" 	// Cevap gelen IP'lerin yazilacagi dosya
#define CEVAPYOK "/var/log/tracker_dead_ips" 	// Cevap gelmeyen IP'lerin yazilacagi dosya

/* The path into gnuplut png files will be copied */
#define HTTPPATH "/var/www/localhost/htdocs/"


struct ayr {
	char MTAHost[51];
	char FromName[51];
	char To1[51];
	char To2[51];
	char To3[51];
	char Subject[51];
	int Period;
	int TrackerPeriod; // When the tracking will start after the last run ?
	char Status[9]; // running or sleeping
	char Tracking[4];
	char LastUpdateTime[17];
	char LastUpdateFinishTime[17];
	char SnmpRO[11];
	char SnmpRW[11];
	char sqlhost[127];
	char sqluser[20];
	char sqlpass[20];
	char sqldb[20];
	char ldaphost[250];
	char ldapbase[250];
	char ldapmanager[250];
	char ldapmanagerpass[250];
	int HistoryCount; /* How many record will be kept in the database for each unique MAC */
	int LocalHistoryCount;  /* How many times TrackedMACNumber will be stored in the LocalStats table */
};


#define LOGFACILITY LOG_LOCAL1
#define CONFIG_FILE "/etc/trackerd.conf"
#define SQLPORT 3306

int IPListAlYaz(struct ayr *ayarlar);
int Ayarlar(struct ayr *ayarlar);
int config_oku(struct ayr *ayarlar);
void mac(u_char *ptr, char *buf);
void usage(void);
void print_statistics(int opt);
void print_statistics_ap(int opt);
int calculate_statistics(struct ayr *ayarlar, char *zaman);
char **switch_listesi_al(char *key, int *switch_sayisi, struct ayr *ayarlar, char *zaman);
char **router_listesi_al(int *switch_sayisi, struct ayr *ayarlar);
int tracker(void);
int ldap_uid_ekle(char yenimac[18], char *zaman, struct ayr *ayarlar);
int simple_send_mail(char *MTAHost, char *from, char *to, char *subject, char *mesaj);
int mysql_query_trackerd(char *query, struct ayr *ayarlar);
int calculate_statistics_ap(struct ayr *ayarlar, char *zaman);
void gnuplot(void);

#endif
